import java.awt.BorderLayout;
import java.awt.EventQueue;

import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.border.EmptyBorder;
import javax.swing.JButton;
import javax.swing.JTextArea;

//import org.omg.CORBA.portable.InputStream;
import java.io.InputStream;
import java.security.CodeSource;

import com.sun.jna.Memory;

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileOutputStream;


public class OMR_Demo extends JFrame {

	private JPanel contentPane;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					OMR_Demo frame = new OMR_Demo();
					frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the frame.
	 */
	 int HandleDIB;
	 String Buffer;
	 int Result;
	 Memory Buffer1 = new Memory(512);
	 Memory Buffer2 = new Memory(512);
	 double DensityPercentage;
	 double SizePercentage;
	 
	/*RecoOMRAPI dlltest=RecoOMRAPI.INSTANCE;
	int HandleDIB;
	String Buffer;
	int Result;
	Memory Buffer1 = new Memory(512);
	Memory Buffer2 = new Memory(512);
	double DensityPercentage;
	double SizePercentage;
	int OMRSession=dlltest.OMR_Init("demo","demo");
	*/
	 /* funzione per estrarre la DLL da richiamare fuori dal .jar. 
	  jna non permette di richiamare le librerie direttamente dal jar*/
	private static boolean extract_File(String fileToExtract){
		try {
			  InputStream in = OMR_Demo.class.getResourceAsStream(fileToExtract);
			  File fileOut = new File("."+fileToExtract);
			  if (fileOut.exists()){
				  System.out.println(fileToExtract+" --> exported");
			  }else
			  {
			  DataOutputStream writer = new DataOutputStream(new FileOutputStream(fileOut));
			  long oneChar = 0;
			  while((oneChar = in.read()) != -1){
			    writer.write((int)oneChar);
			  }
			  writer.close();}
			  in.close();
			} 
			catch (Exception e) {
			  e.printStackTrace();
			}
		return true;
	}	
	
	public OMR_Demo() {
		setTitle("OMR DEMO");
		
		CodeSource codeSource = OMR_Demo.class.getProtectionDomain().getCodeSource();
		try{
			String libpath = System.getProperty("jna.library.path");
		    File jarFile = new File(codeSource.getLocation().toURI().getPath());
		    String jarDir = jarFile.getParentFile().getPath();
			jarDir=jarDir+";"+libpath;
		    System.setProperty("jna.library.path", jarDir); 
		
			libpath = System.getProperty("jna.library.path");
			System.out.println("jna library path --> "+libpath);
			System.out.println("jar         path --> "+jarDir);
		}catch (Exception e) {}

		boolean creato =extract_File("/recoomr.dll");
		boolean creato1 =extract_File("/omrtest.tif");
		
		final RecoOMRAPI dlltest=RecoOMRAPI.INSTANCE;
		
		final int OMRSession=dlltest.OMR_Init("demo","demo");
		
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		setBounds(100, 100, 450, 300);
		contentPane = new JPanel();
		contentPane.setBorder(new EmptyBorder(5, 5, 5, 5));
		contentPane.setLayout(new BorderLayout(0, 0));
		setContentPane(contentPane);
		
		final JTextArea textArea = new JTextArea();
		contentPane.add(textArea, BorderLayout.CENTER);
		
		JButton btnNewButton = new JButton("./omrtest.tif");
		btnNewButton.addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent arg0) {
				//***
				Buffer="";

				// Load the image to recognize
				HandleDIB = dlltest.OMR_LoadImage(OMRSession,"./omrtest.tif");
				// Check if DIB was loaded
				 if (HandleDIB!= 0)
				 {
					// process the check box #1
					  Result=dlltest.OMR_Recognize(OMRSession, HandleDIB, 42, 102, 65, 126);
					  
					  dlltest.OMR_GetMarkDensityPercent (OMRSession, Buffer1);
					  DensityPercentage= Buffer1.getDouble(0); 
					  // get the mark recognized
					  dlltest.OMR_GetMarkSizePercent (OMRSession, Buffer2);
					  SizePercentage=Buffer2.getDouble(0);  
					  // define if the box is checked or not
					  if ((DensityPercentage >= 10) && (SizePercentage >= 40))
					   Buffer = Buffer +"#1 CHECKED ";
					  else
					  {
					   if ((DensityPercentage < 10) && (SizePercentage < 40))
					    Buffer = Buffer + "#1 UNCHECKED ";
					   else
					    Buffer = Buffer + "#1 Unknown ";
					  }
					  Buffer = Buffer + "(" + (DensityPercentage) + "/" + (SizePercentage) + ")";

					  Buffer = Buffer + "\n";

					  // process the check box #2
					  Result = dlltest.OMR_Recognize(OMRSession, HandleDIB, 142, 102, 165, 126);

					  dlltest.OMR_GetMarkDensityPercent (OMRSession, Buffer1);
					  DensityPercentage= Buffer1.getDouble(0); 
					  // get the mark recognized
					  dlltest.OMR_GetMarkSizePercent (OMRSession, Buffer2);
					  SizePercentage=Buffer2.getDouble(0);
					  
					  // define if the box is checked or not
					  if ((DensityPercentage >= 10) && (SizePercentage >= 40))
					   Buffer = Buffer + "#2 CHECKED ";
					  else
					  {
					   if ((DensityPercentage < 10) && (SizePercentage < 40))
					    Buffer = Buffer + "#2 UNCHECKED ";
					   else
					    Buffer = Buffer + "#2 Unknown ";
					  }
					  Buffer = Buffer + "(" + (DensityPercentage) + "/" +(SizePercentage) + ")";

					  Buffer = Buffer + "\n";

					  // process the check box #3
					  Result = dlltest.OMR_Recognize(OMRSession, HandleDIB, 242, 102, 265, 126);

					  dlltest.OMR_GetMarkDensityPercent (OMRSession, Buffer1);
					  DensityPercentage= Buffer1.getDouble(0); 
					  // get the mark recognized
					  dlltest.OMR_GetMarkSizePercent (OMRSession, Buffer2);
					  SizePercentage=Buffer2.getDouble(0);
					  
					  // define if the box is checked or not
					  if ((DensityPercentage >= 10) && (SizePercentage >= 40))
					   Buffer = Buffer + "#3 CHECKED ";
					  else
					  {	  
					   if ((DensityPercentage < 10)&& (SizePercentage < 40))
					    Buffer = Buffer + "#3 UNCHECKED ";
					   else
					    Buffer = Buffer + "#3 Unknown ";
					  }
					  Buffer = Buffer + "(" + (DensityPercentage) + "/" + (SizePercentage) + ")";

					  Buffer = Buffer + "\n";

					  // process the check box #4
					  Result = dlltest.OMR_Recognize(OMRSession, HandleDIB, 342, 102, 365, 126);

					  dlltest.OMR_GetMarkDensityPercent (OMRSession, Buffer1);
					  DensityPercentage= Buffer1.getDouble(0); 
					  
					  // get the mark recognized
					  dlltest.OMR_GetMarkSizePercent (OMRSession, Buffer2);
					  SizePercentage=Buffer2.getDouble(0);
					  
					  // define if the box is checked or not
					  if ((DensityPercentage >= 10) && (SizePercentage >= 40))
					   Buffer = Buffer + "#4 CHECKED ";
					  else
					  {
					   if ((DensityPercentage < 10) && (SizePercentage < 40))
					    Buffer = Buffer + "#4 UNCHECKED ";
					   else
					    Buffer = Buffer + "#4 Unknown ";
					  }
					  Buffer = Buffer + "(" + (DensityPercentage) + "/" + (SizePercentage) + ")";

					  Buffer = Buffer + "/n";

					  // show results
					  textArea.append(Buffer);

					  // Free the image from memory
					  dlltest.OMR_FreeImage(OMRSession, HandleDIB); 
				 }
				 else JOptionPane.showMessageDialog(null, "Image not loaded !");
				
				//****
			}
		});
		dlltest.OMR_Done(OMRSession);
		contentPane.add(btnNewButton, BorderLayout.NORTH);
        
	}

}
